(function () {

    var _instance, helper = _instance || new Helper();

    /**
     *
     * @constructor
     */
    function Helper() {
        //console.info('Helper is init.');
    }

    /**
     *
     * @returns {{}}
     */
    Helper.prototype.getUrlJson = function () {
        var hash = window.location.hash;
        var query = hash.substr(hash.indexOf('?') + 1);
        var result = {};
        query.split("&").forEach(function (part) {
            var item = part.split("=");
            result[item[0]] = decodeURIComponent(item[1]);
        });
        return result;
    };

    /**
     *
     * @param type
     * @param attributesArray
     */
    Helper.prototype.createEl = function (type, attributesArray) { // TODO do more tests
        var element, i = 0;
        element = document.createElement(type);
        for (; i < attributesArray.length; i++) {
            element.setAttribute(attributesArray[i].split(/:(.+)/)[0], attributesArray[i].split(/:(.+)/)[1] || '');
        }
        document.body.appendChild(element);
    };

    /**
     *
     * @param event
     * @param selectorList
     * @param callback
     * @param parentElement
     */
    Helper.prototype.addEvent = function (event, selectorList, callback, parentElement) { // TODO do more tests

        parentElement = document.querySelector(parentElement) || document;

        var _selectorList = selectorList.split(','),
            _elementsMap = [],
            elements,
            i = 0,
            m = 0;

        for (; i < _selectorList.length; i++) {
            elements = parentElement.querySelectorAll(_selectorList[i].trim());
            for (var n = 0; n < elements.length; n++) {
                _elementsMap.push(elements[n]);
            }
        }
        for (; m < _elementsMap.length; m++) {
            _elementsMap[m].addEventListener(event, function (event) {
                callback(event, event.target);
            }, false);
        }
    };

    window.helper = helper;
})();